﻿# -*- coding: utf_8 -*-
import shared
from wxPython.wx import *
from res import *
import pygame

class thbgmPlayer(wxFrame):
	TaskBarIcon = None
	def __init__(self, parent, id, title):

		wxFrame.__init__(self, parent, id, title, size = (416,188), style= wxDEFAULT_FRAME_STYLE)

		ib=wxIconBundle()
		ib.AddIconFromFile(ICON_PROGICON,wxBITMAP_TYPE_ANY)
		self.SetIcons(ib)
		
		self.TaskBarIcon = wxTaskBarIcon()
		EVT_TASKBAR_LEFT_UP(self.TaskBarIcon, self.EvnTray)
		
		self.BuildMenuBar()
		self.BuildToolBar()
		
		shared.status = self.CreateStatusBar()

		panel = wxPanel(self)
		
		self.songChoiceCtl = wxChoice(panel, id=ID_SONG_CHOICE)
		shared.songChoiceCtl = self.songChoiceCtl
		EVT_CHOICE(self, ID_SONG_CHOICE, self.EvnSongChoiceCtl)
		
		shared.slider = wxSlider(panel, style=wxSL_HORIZONTAL | wxSL_AUTOTICKS)
		shared.slider.SetRange(0, 1)
		shared.slider.Enable(False)
		EVT_SCROLL_THUMBTRACK(self, self.EvnSlider)
		EVT_SCROLL_THUMBRELEASE(self, self.EvnSlider)

		shared.songStatus = wxStaticText(panel, style=wxST_NO_AUTORESIZE|wxALIGN_CENTRE)
		shared.songStatus.SetFont(wxFont(12, wxMODERN, wxNORMAL, wxNORMAL, False))
		shared.songStatus.SetLabel("")
		
		sizer = wxFlexGridSizer(cols=1, vgap=0, hgap=0)
#		sizer.AddGrowableRow(2)
		sizer.AddGrowableCol(0)
		sizer.SetFlexibleDirection(wxHORIZONTAL)

		sizer.Add(shared.songChoiceCtl, flag=wxEXPAND)
		sizer.Add(shared.slider, flag=wxEXPAND)
		sizer.Add(shared.songStatus, flag=wxEXPAND)

		panel.SetSizer(sizer)
		panel.SetAutoLayout(True)
		panel.Layout()

		# EVT_CHAR(self, self.EvnKeyPress)
		
		shared.event.post(shared.event.Event(shared.EVENT_FRAMEUPD, {"Ctl":"Init"}))
		self.Show(True)
	def BuildMenuBar(self):
		menuBar = wxMenuBar()
		
		#operationMenu = wxMenu()
		#operationMenu.Append(ID_EXIT, IDS_EXIT)
		#EVT_MENU(self, ID_EXIT, self.OnExit)
		#menuBar.Append(operationMenu, IDS_OPERATION)
		
		helpMenu    = wxMenu()
		helpMenu.Append(ID_ABOUT, IDS_ABOUT)
		EVT_MENU(self, ID_ABOUT, self.OnAbout)
		menuBar.Append(helpMenu, IDS_HELP)

		self.SetMenuBar(menuBar)
	def BuildToolBar(self):
		self.toolBar = self.CreateToolBar()
		shared.toolBar = self.toolBar
		
		self.toolBar.AddTool(ID_CTL_PREV, wxBitmapFromImage(wxImage(ICON_CTL_PREV)))
		self.toolBar.AddRadioTool(ID_CTL_STOP, wxBitmapFromImage(wxImage(ICON_CTL_STOP)))
		self.toolBar.AddRadioTool(ID_CTL_PAUSE, wxBitmapFromImage(wxImage(ICON_CTL_PAUSE)))
		self.toolBar.AddRadioTool(ID_CTL_PLAY, wxBitmapFromImage(wxImage(ICON_CTL_PLAY)))
		self.toolBar.AddTool(ID_CTL_NEXT, wxBitmapFromImage(wxImage(ICON_CTL_NEXT)))
		self.toolBar.SetToolShortHelp(ID_CTL_PREV, IDS_CTL_PREV)
		self.toolBar.SetToolShortHelp(ID_CTL_STOP, IDS_CTL_STOP)
		self.toolBar.SetToolShortHelp(ID_CTL_PAUSE, IDS_CTL_PAUSE)
		self.toolBar.SetToolShortHelp(ID_CTL_PLAY, IDS_CTL_PLAY)
		self.toolBar.SetToolShortHelp(ID_CTL_NEXT, IDS_CTL_NEXT)
		EVT_TOOL(self, ID_CTL_PREV, self.EvnCtl)
		EVT_TOOL(self, ID_CTL_STOP, self.EvnCtl)
		EVT_TOOL(self, ID_CTL_PAUSE, self.EvnCtl)
		EVT_TOOL(self, ID_CTL_PLAY, self.EvnCtl)
		EVT_TOOL(self, ID_CTL_NEXT, self.EvnCtl)
		
		self.toolBar.AddSeparator()
		self.toolBar.AddRadioTool(ID_ORDER_SEQUENCE, wxBitmapFromImage(wxImage(ICON_ORDER_SEQUENCE)))
		self.toolBar.AddRadioTool(ID_ORDER_SHUFFLE, wxBitmapFromImage(wxImage(ICON_ORDER_SHUFFLE)))
		self.toolBar.AddRadioTool(ID_ORDER_REPEAT, wxBitmapFromImage(wxImage(ICON_ORDER_REPEAT)))
		self.toolBar.SetToolShortHelp(ID_ORDER_SEQUENCE, IDS_SEQUENCE)
		self.toolBar.SetToolShortHelp(ID_ORDER_SHUFFLE, IDS_SHUFFLE)
		self.toolBar.SetToolShortHelp(ID_ORDER_REPEAT, IDS_REPEAT)
		EVT_TOOL(self, ID_ORDER_SEQUENCE, self.EvnPlayOreder)
		EVT_TOOL(self, ID_ORDER_SHUFFLE, self.EvnPlayOreder)
		EVT_TOOL(self, ID_ORDER_REPEAT, self.EvnPlayOreder)
		
		self.toolBar.AddSeparator()
		self.toolBar.AddTool(ID_CTL_LOOPINC, wxBitmapFromImage(wxImage(ICON_CTL_LOOPINC)))
		self.toolBar.AddTool(ID_CTL_LOOPDEC, wxBitmapFromImage(wxImage(ICON_CTL_LOOPDEC)))
		self.toolBar.SetToolShortHelp(ID_CTL_LOOPINC, IDS_CTL_LOOPINC)
		self.toolBar.SetToolShortHelp(ID_CTL_LOOPDEC, IDS_CTL_LOOPDEC)
		EVT_TOOL(self, ID_CTL_LOOPINC, self.EvnLoopTimes)
		EVT_TOOL(self, ID_CTL_LOOPDEC, self.EvnLoopTimes)
		
		self.toolBar.AddSeparator()
		self.toolBar.AddCheckTool(ID_TH06_BGM, wxBitmapFromImage(wxImage(ICON_TH06_BGM)))
		self.toolBar.AddCheckTool(ID_TH07_BGM, wxBitmapFromImage(wxImage(ICON_TH07_BGM)))
		self.toolBar.AddCheckTool(ID_TH075_BGM, wxBitmapFromImage(wxImage(ICON_TH075_BGM)))
		self.toolBar.AddCheckTool(ID_TH08_BGM, wxBitmapFromImage(wxImage(ICON_TH08_BGM)))
		self.toolBar.AddCheckTool(ID_TH09_BGM, wxBitmapFromImage(wxImage(ICON_TH09_BGM)))
		self.toolBar.SetToolShortHelp(ID_TH06_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH06_BGM))
		self.toolBar.SetToolShortHelp(ID_TH07_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH07_BGM))
		self.toolBar.SetToolShortHelp(ID_TH075_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH075_BGM))
		self.toolBar.SetToolShortHelp(ID_TH08_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH08_BGM))
		self.toolBar.SetToolShortHelp(ID_TH09_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH09_BGM))
		EVT_TOOL(self, ID_TH06_BGM, self.EvnSelTHBGM)
		EVT_TOOL(self, ID_TH07_BGM, self.EvnSelTHBGM)
		EVT_TOOL(self, ID_TH075_BGM, self.EvnSelTHBGM)
		EVT_TOOL(self, ID_TH08_BGM, self.EvnSelTHBGM)
		EVT_TOOL(self, ID_TH09_BGM, self.EvnSelTHBGM)
		
		self.toolBar.AddSeparator()
		self.toolBar.AddCheckTool(ID_CTL_ENABLETRAY, wxBitmapFromImage(wxImage(ICON_CTL_ENABLETRAY)))
		self.toolBar.SetToolShortHelp(ID_CTL_ENABLETRAY, IDS_MINITOTRAY)
		EVT_TOOL(self, ID_CTL_ENABLETRAY, self.EvnEnableTray)

		self.toolBar.Realize()
		
	def __del__(self):
		shared.programExit.set()
		shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Stop"}))
		shared.event.post(shared.event.Event(pygame.QUIT))
		shared.eventTakerQuit.wait()
		self.TaskBarIcon.Destroy()
	def OnExit(self,event):
		print "onexit"
		self.Close(True)
	def OnClose(self,event):
		print "onclose"
	def OnAbout(self,event):
		dlg = wxMessageDialog(self, IDS_ABOUT_MESSAGE, IDS_ABOUT, wxOK)
		dlg.ShowModal()
		dlg.Destroy()
	def EvnEnableTray(self,event):
		if self.toolBar.GetToolState(event.GetId()) == True:
			self.TaskBarIcon.SetIcon(wxIcon(ICON_CTL_ENABLETRAY, wxBITMAP_TYPE_ICO))
			self.Show(False)
		else:
			self.TaskBarIcon.RemoveIcon()
	def EvnTray(self,event):
		self.TaskBarIcon.RemoveIcon()
		self.toolBar.ToggleTool(ID_CTL_ENABLETRAY, False)
		self.Show(True)
	def EvnCtl(self,event):
		if event.GetId() is ID_CTL_PLAY:
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Play"}))
		elif event.GetId() is ID_CTL_PAUSE:
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Pause"}))
		elif event.GetId() is ID_CTL_STOP:
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Stop"}))
		elif event.GetId() is ID_CTL_PREV:
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Prev"}))
		elif event.GetId() is ID_CTL_NEXT:
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Next"}))
	def EvnKeyPress(self,event):
		if event.GetKeyCode() == ord('z') or event.GetKeyCode() == ord('Z'):
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Prev"}))
		elif event.GetKeyCode() == ord('x') or event.GetKeyCode() == ord('X'):
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Stop"}))
		elif event.GetKeyCode() == ord('c') or event.GetKeyCode() == ord('C'):
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Pause"}))
		elif event.GetKeyCode() == ord('v') or event.GetKeyCode() == ord('V'):
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Play"}))
		elif event.GetKeyCode() == ord('b') or event.GetKeyCode() == ord('B'):
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Next"}))
	def EvnSlider(self,event):
		if event.GetEventType() == wxEVT_SCROLL_THUMBTRACK:
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Scrolling", "Pos":shared.slider.GetValue()}))
		elif event.GetEventType() == wxEVT_SCROLL_THUMBRELEASE:
			shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Scroll", "Pos":shared.slider.GetValue()}))
	def EvnSongChoiceCtl(self,event):
		shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Choice", "idx":self.songChoiceCtl.GetSelection()}))
	def EvnSelTHBGM(self,event):
		series = shared.thBGMdata.refResToSeries(event.GetId())
		if self.toolBar.GetToolState(event.GetId()) == False: 
			shared.playingInfo.userEnableSeries(series, False)
			if shared.playingInfo.isPlayable() is False:
				shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Stop"}))
		else:
			if shared.playingInfo.userEnableSeries(series, True) is False:
				dlg = wxDirDialog(self)
				if (dlg.ShowModal() == wxID_OK):
					if shared.thBGMdata.selfCerSeriesPathExam(series, dlg.GetPath()) is True:
						shared.playingInfo.userEnableSeries(series, True)
						dlg.Destroy()
					else:
						dlgMsg = wxMessageDialog(self, IDS_FAILEDTOLOC, IDS_FAILED, style = wxOK)
						dlgMsg.ShowModal()
						dlgMsg.Destroy()
						self.toolBar.ToggleTool(event.GetId(), False)
				else:
					self.toolBar.ToggleTool(event.GetId(), False)
		shared.event.post(shared.event.Event(shared.EVENT_FRAMEUPD, {"Ctl":"UpdateSelTHBGM"}))
	def EvnPlayOreder(self,event):
		shared.event.post(shared.event.Event(shared.EVENT_INFOUPD, {"Ctl":"SetPlayingOrder", "evnId":event.GetId()}))
	def EvnLoopTimes(self,event):
		if event.GetId() == ID_CTL_LOOPINC:
			shared.playingInfo.incLoopPlayTimes()
		elif event.GetId() == ID_CTL_LOOPDEC:
			shared.playingInfo.decLoopPlayTimes()

class thbgmPlayerMain(wxApp):
	def OnInit(self):
		frame = thbgmPlayer(None, -1, IDS_TITLE)
		self.SetTopWindow(frame)
		return true
	def OnExit(self):
		pass

def run():
	app = thbgmPlayerMain(redirect = 0)
	app.MainLoop()

