﻿# -*- coding: utf_8 -*-
import shared
import thBGMdata
import threading, random
from res import *
from otherfunction import *

playingOrderResToKey = {
	ID_ORDER_REPEAT:"Repeat", 
	ID_ORDER_SEQUENCE:"Sequence", 
	ID_ORDER_SHUFFLE:"Shuffle"
	}
playingOrderKeyToRes = {}
for cur_key in playingOrderResToKey:
	playingOrderKeyToRes[playingOrderResToKey[cur_key]] = cur_key
	
blockSize   = 44100*2 # 44100*4 = 1 sec

curTrack	= 0
curSeriesKey	= None
curMagicTable	= {}
workingSeriesDict	= {}
loopPlayTimes	= 0

curIdx	= None
songChoiceCtlMap	= {}

curPlayResOrder	= ID_ORDER_REPEAT
repeatPlaying	= threading.Event()
sequencePlaying	= threading.Event()
prevPlayedIdxList	= []
nextPlayedIdxList	= []

def updateSongChoiceCtl():
	global curTrack, curSeriesKey, workingSeriesDict, curIdx, songChoiceCtlMap, songChoiceCtlMapToIdx, nextPlayedIdxList, prevPlayedIdxList
	if isPlayable() is False:
		keys = workingSeriesDict.keys()
		keys.sort()
		for curKey in keys:
			if workingSeriesDict[curKey] is True:
				curSeriesKey = curKey
				curTrack = 1
				break
	shared.songChoiceCtl.Clear()
	songChoiceCtlMap = {}
	songChoiceCtlMapToIdx = {}
	keys = workingSeriesDict.keys()
	keys.sort()
	for forKey in keys:
		if workingSeriesDict[forKey] is True:
			shared.songChoiceCtl.Append("--------%s--------"%(shared.thBGMdata.seriesMagicTable[forKey][0]["seriesFullName"]))
			for forTrack in range(1, len(shared.thBGMdata.seriesMagicTable[forKey])):
				magicTable = shared.thBGMdata.seriesMagicTable[forKey][forTrack]
				songName = magicTable[shared.thBGMdata.magicTableKeyToIndex["songName"]]
				fullLength = magicTable[shared.thBGMdata.magicTableKeyToIndex["fullLength"]]
				idx = shared.songChoiceCtl.Append("%s %02d:(%s) %s"%(forKey, forTrack, secToStr(fullLength/(44100*4),2), songName))
				songChoiceCtlMap[idx] = (forKey, forTrack)
				if forKey == curSeriesKey and forTrack == curTrack:
					shared.songChoiceCtl.SetSelection(idx)
					curIdx	= idx
	nextPlayedIdxList = []
	prevPlayedIdxList = []

def updateSongChoiceSel():
	global curIdx
	if shared.songChoiceCtl.GetSelection() != curIdx:
		shared.songChoiceCtl.SetSelection(curIdx)
		
def setCurPlaySongByChoiceIdx(idx):
	global curTrack, curSeriesKey, curIdx, songChoiceCtlMap
	if curIdx is idx:
		return False
	elif songChoiceCtlMap.has_key(idx):
		curIdx	= idx
		curSeriesKey	= songChoiceCtlMap[idx][0]
		curTrack	= songChoiceCtlMap[idx][1]
		return True
	else:
		if idx < curIdx:
			if idx-1 < 0: # an exception
				shared.songChoiceCtl.SetSelection(idx+1)
				return setCurPlaySongByChoiceIdx(idx+1)
			else: return setCurPlaySongByChoiceIdx(idx-1)
		elif idx > curIdx:
			return setCurPlaySongByChoiceIdx(idx+1)
		else:
			return False

def setCurPlayOrderByRes(res):
	global curPlayResOrder
	shared.pref.set("thBGMsetting", "playingOrder", playingOrderResToKey[res])
	curPlayResOrder = res
	if curPlayResOrder is ID_ORDER_REPEAT:
		repeatPlaying.set()
	else:
		repeatPlaying.clear()
		if curPlayResOrder is ID_ORDER_SEQUENCE:
			sequencePlaying.set()
		else:
			sequencePlaying.clear()

def incLoopPlayTimes():
	global loopPlayTimes
	loopPlayTimes += 1
	if loopPlayTimes > 9: loopPlayTimes = 9
	shared.pref.set("thBGMsetting", "loopPlayTimes", loopPlayTimes)
	
def decLoopPlayTimes():
	global loopPlayTimes
	loopPlayTimes -= 1
	if loopPlayTimes < 0: loopPlayTimes = 0
	shared.pref.set("thBGMsetting", "loopPlayTimes", loopPlayTimes)

def userEnableSeries(curSeriesKey, boolFlag):
	global workingSeriesDict
	if boolFlag is False:
		workingSeriesDict[curSeriesKey] = False
	else:
		workingSeriesDict[curSeriesKey] = thBGMdata.selfCerSeriesPathExam(curSeriesKey)
	shared.pref.set("thBGMsel", curSeriesKey, workingSeriesDict[curSeriesKey])
	return workingSeriesDict[curSeriesKey]
		
def isPlayable():
	global curTrack, curSeriesKey, curIdx, workingSeriesDict
	if curTrack is 0 or curSeriesKey is None or curIdx is None:
		return False
	elif workingSeriesDict[curSeriesKey] is False:
		curSeriesKey = curIdx = None
		return False
	else: 
		return True
	
def fullSeriesExam():
	global workingSeriesDict
	for seriesKey in thBGMdata.seriesKeyList:
		workingSeriesDict[seriesKey] = thBGMdata.selfCerSeriesPathExam(seriesKey)
		
def getLooperInput():
	global curTrack, curSeriesKey
	if isPlayable() is False: return False
	updateSongChoiceSel()
	getCurTrackInfoMap()# made an update
	return thBGMdata.getLooperInput(curSeriesKey, curTrack)

def getCurTrackInfoMap():
	global curTrack, curSeriesKey, curMagicTable
	if isPlayable() is False: return Fales
	magicTable = {}
	for key in thBGMdata.magicTableKeyToIndex:
		magicTable[key] = thBGMdata.seriesMagicTable[curSeriesKey][curTrack][thBGMdata.magicTableKeyToIndex[key]]
	curMagicTable	= magicTable
	return magicTable

def getCurTrackName():
	if isPlayable() is False: return str()
	return getCurTrackInfoMap().get("songName")
	
def selNextTrack():
	global curTrack, curSeriesKey, curIdx, workingSeriesDict, nextPlayedIdxList, prevPlayedIdxList, songChoiceCtlMap
	if isPlayable() is False: return
	if sequencePlaying.isSet() or repeatPlaying.isSet():
		keys	= songChoiceCtlMap.keys()
		keys.sort()
		headKey	=  keys[0]
		keys.reverse()
		if curIdx in keys:
			lastKey	= None
			for curKey in keys:
				if curKey == curIdx: break
				else: lastKey = curKey
			if lastKey is None: setCurPlaySongByChoiceIdx(headKey)
			else: setCurPlaySongByChoiceIdx(lastKey)
		else:
			raise "error in selNextTrack():"
	else:
		if len(nextPlayedIdxList) >= 2:
			tempKey = nextPlayedIdxList.pop(len(nextPlayedIdxList)-1)
			if tempKey is curIdx: tempKey = nextPlayedIdxList.pop(len(nextPlayedIdxList)-1)
		else:
			if len(prevPlayedIdxList) == len(songChoiceCtlMap):
				prevPlayedIdxList = []
			keys	= songChoiceCtlMap.keys()
			foundKey = False
			while foundKey is False:
				tempKey	= random.choice(keys)
				if tempKey != curIdx and (tempKey in prevPlayedIdxList) is False:
					foundKey = True
		prevPlayedIdxList.append(tempKey)
		setCurPlaySongByChoiceIdx(tempKey)
	updateSongChoiceSel()
		
def selPrevTrack():
	global curTrack, curSeriesKey, curIdx, workingSeriesDict, nextPlayedIdxList, prevPlayedIdxList, songChoiceCtlMap
	if isPlayable() is False: return
	if sequencePlaying.isSet() or repeatPlaying.isSet():
		keys	= songChoiceCtlMap.keys()
		keys.sort()
		tailKey	=  keys[len(keys)-1]
		if curIdx in keys:
			lastKey	= None
			for curKey in keys:
				if curKey == curIdx: break
				else: lastKey = curKey
			if lastKey is None: setCurPlaySongByChoiceIdx(tailKey)
			else: setCurPlaySongByChoiceIdx(lastKey)
		else:
			raise "error in selPrevTrack():"
	else:
		if len(prevPlayedIdxList) >= 2:
			tempKey = prevPlayedIdxList.pop(len(prevPlayedIdxList)-1)
			if tempKey is curIdx: tempKey = prevPlayedIdxList.pop(len(prevPlayedIdxList)-1)
		else:
			if len(nextPlayedIdxList) == len(songChoiceCtlMap):
				nextPlayedIdxList = []
			keys	= songChoiceCtlMap.keys()
			foundKey = False
			while foundKey is False:
				tempKey	= random.choice(keys)
				if tempKey != curIdx and (tempKey in nextPlayedIdxList) is False:
					foundKey = True
		nextPlayedIdxList.append(tempKey)
		setCurPlaySongByChoiceIdx(tempKey)
	updateSongChoiceSel()
